#import <Foundation/Foundation.h>

/*json dict keys*/

#define kHACKNAME @"hackName"
#define kHACKAUTHOR @"hackAuthor"
#define kHACKVERSION @"hackVersion"
#define kHACKSHORTVERSION @"hackShortVersion"
#define kHACKS @"hacks"
#define kSUBHACKNAME @"subhackName"
#define kSUBHACKPATCHES @"patches"
#define kPATCHTYPE @"type"
#define kPATCHADDRESS @"address" // number
#define kPATCHDATA @"data" // number

#define kPATCH_BYTE @"byte"
#define kPATCH_WORD @"word"
#define kPATCH_DWORD @"dword"
#define kPATCH_QWORD @"qword"

#define kPATCH_CHAR kPATCH_BYTE
#define kPATCH_SHORT kPATCH_WORD
#define kPATCH_UINT kPATCH_DWORD
#define kPATCH_ULL kPATCH_QWORD

#define kPATCH_8 kPATCH_BYTE
#define kPATCH_16 kPATCH_WORD
#define kPATCH_32 kPATCH_DWORD
#define kPATCH_64 kPATCH_QWORD


@interface hack : NSObject
{
    NSString *_hackname;
    NSString *_hackauthor;
    NSString *_targetshortversion;
    NSString *_targetversion;
    
    NSArray *_hacks;    // NSDictionaries
}
-(id)initWithHackFile:(NSString*)hackFilePath;

-(NSUInteger)hackCount;

-(NSArray*)hackNames;

@property (nonatomic, retain) NSString *hackname;
@property (nonatomic, retain) NSString *hackauthor;
@property (nonatomic, retain) NSString *targetversion;
@property (nonatomic, retain) NSString *targetshortversion;
@property (nonatomic, retain) NSArray  *hacks;
@end


