#import "process_info.h"

__attribute__((always_inline)) vm_address_t _vm_get_slide()
{
    return reinterpret_cast<vm_address_t>(_dyld_get_image_header(0));
}

__attribute__((always_inline)) vm_address_t vm_get_slide()
{
    return _dyld_get_image_vmaddr_slide(0);
}

__attribute__((always_inline)) cpu_subtype_t get_current_cpu_subtype(void)
{
    return _dyld_get_image_header(0)->cpusubtype;
}