#include <string>
#include <iostream>
#import <Foundation/Foundation.h>
#import <mach/mach.h>
#import "process_info.h"
#include <libkern/OSCacheControl.h>

using namespace std;


template <typename T> BOOL patch(T *address, T data) //    address is vm offset from ida NOT FILE OFFSET OMGOMOGMOGM
{
        memory_object_name_t object;
        vm_region_basic_info_data_t info;
        mach_msg_type_number_t info_count = VM_REGION_BASIC_INFO_COUNT;
        vm_region_flavor_t flavor = VM_REGION_BASIC_INFO;
        
        vm_address_t region_start = reinterpret_cast<vm_address_t>(address);
        vm_size_t region_size = 0;
        
        kern_return_t err = vm_region(mach_task_self(), &region_start, &region_size, flavor, (vm_region_info_t)&info, (mach_msg_type_number_t*)&info_count, (mach_port_t*)&object);
        
        if(err != ERR_SUCCESS)
        {
            NSLog(@"Fatal error: vm_region() returned other than ERR_SUCCESS");
            return NO;
        }
    
            //   set cur prot
        kern_return_t er = vm_protect(mach_task_self(), region_start, region_size, NO, VM_PROT_READ | VM_PROT_WRITE | VM_PROT_COPY  );
        if( er != KERN_SUCCESS)
        {
                NSLog(@"Fatal error: vm_protect(mach_task_self(), region_start, region_size, NO, VM_PROT_READ | VM_PROT_WRITE) returned other than KERN_SUCESS");
                return NO;
        }
            
            // protections set
        NSLog(@"SUCCESS: VM Protections set properly");
        
        //  All that shit just to do this lmao
/*
    if((reinterpret_cast<uintptr_t>(address) & 0x1)) // align address
    {
        address = (T*)((uintptr_t)address-1);
    }
 */
    
    *address = data;
    
    sys_dcache_flush((void*)address, sizeof(T));
    sys_icache_invalidate((void*)address, sizeof(T));

    vm_protect(mach_task_self(), region_start, region_size, NO, VM_PROT_EXECUTE | VM_PROT_READ); 

    return YES;
}

    
